﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace XamDataGridActiveItem
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var collectionView = new CollectionViewSource();
            var groupDescription = new PropertyGroupDescription("Age");
            groupDescription.GroupNames.Add("Group 1");
            groupDescription.GroupNames.Add("Group 2"); 
            groupDescription.GroupNames.Add("Group 3"); 
            collectionView.GroupDescriptions.Add(groupDescription);

            collectionView.Source = new ViewModel().Data;

            this.DataContext = collectionView;
        }

        private void GroupByRecordPresenter_Loaded(object sender, RoutedEventArgs e)
        {
            (sender as GroupByRecordPresenter).Record.Description =
                 ((sender as GroupByRecordPresenter).Record as GroupByRecord).Value.ToString() + (sender as GroupByRecordPresenter).Record.Description;
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private int id;

        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("Id");
            }
        }

        private double age;

        public double Age
        {
            get { return age; }
            set { age = value; NotifyPropertyChanged("Age"); }
        }

        private String lastName;

        public String LastName
        {
            get { return lastName; }
            set { lastName = value; NotifyPropertyChanged("LastName"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }

        }

    }

    public class ViewModel
    {
        public ObservableCollection<Person> Data { get; set; }

        public ViewModel()
        {
            Data = new ObservableCollection<Person>();
        }
    }
}
